locals {
  principals = [
    for id in var.account_ids :
    join("", ["arn:aws:iam::", id, ":root"])
  ]
}

data "template_file" "policy" {
  template = file("${path.module}/policy.json")

  vars = {
    principals  = jsonencode(local.principals)
    bucket_name = var.bucket_name
  }
}

resource "aws_s3_bucket_policy" "policy" {
  bucket = var.bucket_name
  policy = data.template_file.policy.rendered
}
