resource "aws_ecr_repository" "repo" {
  name                 = var.name
  image_tag_mutability = "MUTABLE"

  image_scanning_configuration {
    scan_on_push = false
  }

  encryption_configuration {
    encryption_type = "KMS"
  }

  tags = merge(var.tags, tomap({ "managed" : "terraform" }))
}

resource "aws_ecr_lifecycle_policy" "remove_untagged" {
  repository = aws_ecr_repository.repo.name

  policy = data.template_file.untagged_lifecycle_policy.rendered
}

resource "aws_ecr_repository_policy" "access" {
  count      = var.access_policy != "" ? 1 : 0
  policy     = var.access_policy
  repository = aws_ecr_repository.repo.name
}
